
; In Racket, you can use #lang racket

(define fibonacci-cached
  (let ((cache '()))
    (let ((cache-value (lambda (n value)
                         (set! cache (cons (list n value) cache))))
          (value-of    (lambda (n)
                         (cadr (assoc n cache))))
          (in-cache?   (lambda (n)
                         (assoc n cache))))
      (lambda (n)
        "Computes the nth Fibonacci number and saves it."
        (if (in-cache? n)
            (value-of n)
            (let ((value (if (< n 2)
                             1
                             (+ (fibonacci-cached (- n 1))
                                (fibonacci-cached (- n 2))))))
              (cache-value n value)
              value)) ))))